%Replication MATLAB/DYNARE code for 
%'Gauging the Effects of Fiscal Stimulus Packages in the Euro Area'
%by G. Coenen, R. Straub and M. Trabandt
%Journal of Economic Dynamics and Control (forthcoming)

%New Area-Wide model with extended fiscal sector

%Dynare Version 4.2.0 used for calculations

%November, 2012



%Endogenous variables
var lambda Q rK piC s i w N piH piX pY pIM imI pI im epsilonRPG  
x  r k y imC c cI cJ trI trJ bstar pH pX piY  piI piIM b epsilonRPstar 
gz epsilon epsilonI varphiW varphiH  varphiX varphistar epsilonIM nustar g 
tr tauC tauWf tauWh tauN lump aiG iG piYstar ystar rstar pO pCX cItilde 
ktilde kG Dy_obs Dc_obs Di_obs Dx_obs Dim_obs E Dwn_obs Dystar_obs dtxwin_obs
piIM_obs piY_obs piC_obs r_obs piYstar_obs rstar_obs b_obs;


%Shocks
varexo  
etaRPG etaRPstar etagz etaepsilon etaI etavarphiW etavarphiH 
etavarphiX etavarphistar etaIM etanustar etaR  etaPiYstar etaYstar etaRstar 
etapO etapCX  
etag etatr etatauC etatauWf etatauWh etatauN etaaiG etaL  
MEDy_eps MEDx_eps MEDim_eps MEpiIM_eps MEpiY_eps MEb_eps MEpiC_eps  
MPswitch FPswitch;

 

parameters  Pibar  gzbar betta delta rKbar pIbar
gammaBstar sbar ybar kappa xiW chiW xiH chiH xiX chiX           
xistar chistar omegastar muC muI mustar gammaI gammaIMC gammaIMI       
gammastar phiR phiPi phiDPi phiDY xiE tauKbar  tauCbar  tauNbar tauWhbar 
tauWfbar b0 omega tr2rot cJcISSratio CorpGovSpread epsRPKbar GovRSpread 
sC varphiWbar zetaa psi alfa kGbar kbar
xi1 xi2 betastar nuCbar hCbar qCbar imCbar pHbar pIMbar nuIbar
hIbar qIbar imIbar imbar phiY hbar hGbar hIGbar xbar cbar pYbar
ibar pGbar gbar pIGbar iGbar pXbar Rstarbar PiYstarbar bbar 
trbar wbar Nbar Rgovbar cIbar cItildebar ktildebar deltaG b1
cJbar aabar sIMC sIMI sI sG sIG varphiHbar KG_K_target
KY_target dtx_ybar_target sTR tauCrevYbar_target tauWfrevYbar_target
tauWhrevYbar_target pCbar sBbar gEbar Rbar nom_Rtarget
epsRPGbar epsRPstarbar lamRPstar given_alphaG given_alphaK 
alphaG_target alphaK_target nuG nuK alphaK alphaG rhoRPG sigmaRPG sigmapCX 
thetaLB thetaLY thetaGB thetaGY thetatrB thetatrY thetaaiGB 
thetaaiGY thetatauCB thetatauCY thetatauWfB thetatauWfY thetatauWhB thetatauWhY 
thetatauNB thetatauNY thetatauKB thetatauKY rhoRPstar rhogz rhoepsilon     
rhoI rhovarphiW rhovarphiH rhovarphiX rhovarphistar rhoIM rhonustar 
sigmaRPstar sigmagz sigmaepsilon sigmaI sigmavarphiW sigmavarphiH   
sigmavarphiX sigmavarphistar sigmaIM sigmanustar sigmaR rhog      
preag sigmag rhotr preatr sigmatr rhoaiG preaaiG sigmaaiG     
rhotauC preatauC sigmatauC rhotauWf preatauWf sigmatauWf rhotauWh       
preatauWh sigmatauWh rhotauN preatauN sigmatauN rhotauK preatauK
sigmatauK rhoL preaL sigmaL B1piYstarpiYstar                                                                                                                                                                                                                                                                 
B1ystarystar B1rstarrstar B1pOpO B1pCXpCX varsigma  trJbar trIbar 
epsilonNhat epsilonChat epsilonRPKhat tauKhat tauKhatp1 chiWtilde tauKRevybar tauNRevybar
sigmaPiYstar sigmaYstar sigmaRstar sigmapO B2ystarystar 
sigMEDy_eps  sigMEDx_eps  sigMEDim_eps sigMEpiIM_eps  
sigMEpiY_eps  RgovRealAnnual root1ystar root2ystar Kimball sigMEb_eps 
rhoMAvarphiH rhoMAvarphiX rhoMAvarphistar rhoMAvarphiW sigMEpiC_eps;




%Initialize parameters
kappa          	=	0.8;
xiW            	=	0.75;
chiW           	=	0.75;
chiWtilde       =   0;
xiH            	=	0.75;
chiH           	=	0.75;
xiX            	=	0.75;
chiX           	=	0.75;
xistar         	=	0.75;
chistar        	=	0.75;
omegastar	    =	0.15;
muC         	=	1.5;
muI             =	1.5;
mustar         	=	1.05;
gammaI         	=	4;
gammaIMC       	=	2.5;
gammaIMI       	=	2.5;
gammastar      	=	2.5;
phiR           	=	0.7;
phiPi          	=	1.8;
phiDPi         	=	0.3;
phiDY          	=	0.2;
phiY            =   0.1; 
xiE            	=	0.75;
gEbar             = 1.002; 
gztilde           = 0.003;
gzbar             = 1+gztilde;
betta             = 1/1.00625*gzbar; 
Pibar             = 1.00475;
zetaa             = 2;
varsigma          = 1;  
varphiWbar        = 1.30;
alfa              = 0.3; 
varphiHbar        = 1.35;
gammaBstar        = 0.01;
pCbar             = 1.00;
pIMbar            = 1.00;
sbar              = 1.00;  
sI                = 0.183;
sG                = 0.215;
sIG               = 0.028; 
sIMC              = 0.10;
sIMI              = 0.06;
sTR               = 0.169;
sBbar             = 2.4;                            
KG_K_target       = 0.15;
KY_target           = 1.75;
dtx_ybar_target     = 0.118;
tauCrevYbar_target  = 0.128;
tauWfrevYbar_target = 0.084;
tauWhrevYbar_target = 0.080;
given_alphaG        =   1;
given_alphaK        =   1;
alphaG_target       =   0.75;
alphaK_target       =   0.9;
nuG                 =	1;
nuK                 =   1;
b0                  =	1;
omega               =	0.25; 
tr2rot              =	0.75;  
cJcISSratio         =	0.8;
nom_Rtarget         =  1+4.4/400;
CorpGovSpread       =	0;
GovRSpread          =	0;
epsilonNhat         =   0;
epsilonChat         =   0;
epsilonRPKhat       =   0;
tauKhat             =   0;
tauKhatp1           =   0;
rhoRPstar           =	0.0;
rhogz               =	0;
rhoepsilon          =	0.0;
rhoI                =	0.0;
rhovarphiW          =	0.0;
rhovarphiH          =	0.0;
rhovarphiX          =	0.0;
rhovarphistar       =	0.0;
rhoIM               =	0.0;
rhonustar           =	0.0;
rhoRPG              =	0.0;
sigmaRPstar         =	0;
sigmagz             =	0;
sigmaepsilon        =	0;
sigmaI              =	0;
sigmavarphiW        =	0;
sigmavarphiH        =	0;
sigmavarphiX        =	0;
sigmavarphistar     =	0;
sigmaIM             =	0;
sigmanustar         =	0;
sigmaR              =	0; 
sigmaRPG            =	0; 
rhog                =	0.86732;
sigmag              =	0.4984;
rhotr               =	0.78403;
sigmatr             =	2.05;
rhoaiG              =	0.86013;
sigmaaiG            =	3.2113;
rhotauC             =	0.9458;
sigmatauC           =	0.15941;
rhotauWf            =	0.87226;
sigmatauWf          =	0.14101;
rhotauWh            =	0.89304;
sigmatauWh          =	0.17328;
rhotauN             =	0.92583;
sigmatauN           =	0.50182;
rhotauK             =	0;
sigmatauK           =	0;
rhoL                =	0;
sigmaL              =	0;
preaaiG             =	0;
preatauC            =	0;
preatauWf           =	0;
preatauWh           =	0;
preatauN            =	0;
preatauK            =	0;
preaL               =	0;
preatr              =	0;
preag               =	0;
thetaLB             =	1;
thetaLY             =	0;
thetaGB             =	0;
thetaGY             =	0;
thetatrB            =	0;
thetatrY            =	0;
thetaaiGB           =	0;
thetaaiGY           =	0;
thetatauCB          =	0;
thetatauCY          =	0;
thetatauWfB         =	0;
thetatauWfY         =	0;
thetatauWhB         =	0;
thetatauWhY         =	0;
thetatauNB          =	0;
thetatauNY          =	0;
thetatauKB          =	0;
thetatauKY          =	0;                                                                                                                                                                                                                                                                     
B1piYstarpiYstar    =   0.60277;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
sigmaPiYstar        =   0.3047;
B1rstarrstar        =   0.97124;               
sigmaRstar          =   0.13243; 
B1pOpO              =   0.87757;                       
sigmapO             =   15.1687;
B1pCXpCX            =   0.90385;                          
sigmapCX            =   1.0863;
root1ystar          =   0.95;
root2ystar          =   0.6;
sigmaYstar          =   0; 
sigMEpiY_eps        =   0.1;
sigMEpiC_eps        =   0.1; 
sigMEDy_eps         =   0.1;
sigMEDx_eps         =   1;
sigMEDim_eps        =   1;
sigMEpiIM_eps       =   1;
sigMEb_eps          =   0; 
Kimball             =   33;   
rhoMAvarphiH        =   0;	 	 
rhoMAvarphiX        =   0; 	 	 
rhoMAvarphistar     =   0;	 	 
rhoMAvarphiW        =   0;


 



 
model (linear);
//Core Model Equations
%1 ConsFOC 
lambda        = - varsigma*1/(1-kappa/gzbar)*cItilde + varsigma*(kappa/gzbar)/(1-kappa/gzbar)*cItilde(-1)
                - varsigma*(kappa/gzbar)/(1-kappa/gzbar)*gz - 1/(1+tauCbar)*tauC + 1/nuG*(cItilde-cI) + epsilonChat
                +(varsigma-1)/(1+zetaa)*Nbar^(1+zetaa)*( (1+zetaa)*N+epsilonNhat-epsilonChat);

%2 InvestFOC 
pI            =   Q + (gammaI*gzbar^2*(1+betta*gzbar^(1-varsigma)))*epsilonI
                  + gammaI*gzbar^2*(  betta*gzbar^(1-varsigma)*(  i(+1) - i) - (  i - i(-1) ) + betta*gzbar^(1-varsigma)*gz(+1)  - gz);

%3 CapitalFOC 
Q             =   betta*(1-delta)*epsRPKbar/gzbar^(varsigma)*Q(+1) + lambda(+1) - lambda - varsigma*gz(+1) + epsilonRPKhat
                  - betta*(1-tauKbar)*rKbar/gzbar^(varsigma)/pIbar*epsRPKbar*(  1/(1-tauKbar)*tauKhatp1 - rK(+1))
                  + betta*delta/gzbar^(varsigma)*epsRPKbar*( tauKbar*pI(+1) + tauKhatp1);

%4 EulerFOC for gov. bonds
lambda        =   lambda(+1) - varsigma*gz(+1) + epsilonRPG + r - piC(+1);

%5 UIP 
epsilonRPG + r - rstar  =   s(+1) - s + piY(+1) - piYstar(+1)
                            - gammaBstar*lamRPstar*sbar/ybar*bstar - lamRPstar*epsilonRPstar;

%6 CapitalAccum
k             =   (1-delta)/gzbar*k(-1) - (1-delta)/gzbar*gz
                          + (1-(1-delta)/gzbar)*(gammaI*gzbar^2*(1+betta*gzbar^(1-varsigma)))*epsilonI
                          + (1-(1-delta)/gzbar)*i;

%7 WagePhillips
w             =   betta*gzbar^(1-varsigma)/(1+betta*gzbar^(1-varsigma))*w(+1) + 1/(1+betta*gzbar^(1-varsigma))*w(-1) + betta*gzbar^(1-varsigma)/(1+betta*gzbar^(1-varsigma))*piC(+1) 
                            - (1+betta*gzbar^(1-varsigma)*chiW)/(1+betta*gzbar^(1-varsigma))*piC + chiW/(1+betta*gzbar^(1-varsigma))*piC(-1)
                            - 1/(1+betta*gzbar^(1-varsigma))*(1-chiWtilde)*(  gz - betta*gzbar^(1-varsigma)*gz(+1))                           
                            - (1-betta*gzbar^(1-varsigma)*xiW)*(1-xiW)/((1+betta*gzbar^(1-varsigma))*xiW*(1+varphiWbar/(varphiWbar-1)*zetaa+(varsigma-1)*Nbar^(1+zetaa)*varphiWbar/(varphiWbar-1)))*
                           ( - 1/(1-tauNbar-tauWhbar)*(tauN+tauWh) + w - 
                           ( (1-varsigma)/(1-kappa/gzbar)*(cItilde-kappa/gzbar*cItilde(-1)+kappa/gzbar*gz)+(varsigma-1)/(1+zetaa)*Nbar^(1+zetaa)*((1+zetaa)*N+epsilonNhat-epsilonChat)+epsilonNhat+zetaa*N - lambda)
                            ) + varphiW; 

%8 Production
y             =   (1+psi/ybar)*(  epsilon + alfa*(ktilde - gz) + (1-alfa)*N );

%9 FirmsCostMin
rK            =   gz + N + 1/(1+tauWfbar)*tauWf + w  - k(-1)
                        - (nuK-1)/nuK*( ((1-alphaK)/alphaK )^(1/nuK)*(kGbar/kbar)^((nuK-1)/nuK ) )/
                        ( 1+((1-alphaK)/alphaK )^(1/nuK)*(kGbar/kbar)^( (nuK-1)/nuK ) )*( kG(-1)-k(-1) );

%10 DomesticPhillips
piH           =   betta*gzbar^(1-varsigma)/(1+betta*gzbar^(1-varsigma)*chiH)*piH(+1) + chiH/(1+betta*gzbar^(1-varsigma)*chiH)*piH(-1)
                          + (1-betta*gzbar^(1-varsigma)*xiH)*(1-xiH)/(xiH*(1+betta*gzbar^(1-varsigma)*chiH)*(1+(varphiHbar-1)*Kimball))*(  
                            ( 1/(1-alfa*xi1)*( - epsilon + (1-xi1)*alfa*rK + (1-alfa)*(  1/(1+tauWfbar)*tauWf  + w)
                             + (1-xi1)*xi2*alfa*( kG(-1)-k(-1) ) - xi1*alfa*kG(-1) + xi1*alfa*gz  
                             + xi1*alfa/(1+psi/ybar)*y) ) - pH ) + varphiH;

%11 ExportPhillips
piX           =   betta*gzbar^(1-varsigma)/(1+betta*gzbar^(1-varsigma)*chiX)*piX(+1) + chiX/(1+betta*gzbar^(1-varsigma)*chiX)*piX(-1)
                          + (1-betta*gzbar^(1-varsigma)*xiX)*(1-xiX)/(xiX*(1+betta*gzbar^(1-varsigma)*chiX)*(1+(varphiHbar-1)*Kimball))*(
                          (1/(1-alfa*xi1)*( - epsilon + (1-xi1)*alfa*rK + (1-alfa)*(  1/(1+tauWfbar)*tauWf  + w)
                          + (1-xi1)*xi2*alfa*( kG(-1)-k(-1) ) - xi1*alfa*kG(-1) + xi1*alfa*gz  
                          + xi1*alfa/(1+psi/ybar)*y) )- pX ) + varphiX;

%12 ImportPhillips
piIM          =   betastar*gzbar^(1-varsigma)/(1+betastar*gzbar^(1-varsigma)*chistar)*piIM(+1) + chistar/(1+betastar*gzbar^(1-varsigma)*chistar)*piIM(-1)
                          + (1-betastar*gzbar^(1-varsigma)*xistar)*(1-xistar)/(xistar*(1+betastar*gzbar^(1-varsigma)*chistar)*(1+(varphiHbar-1)*Kimball))*(  s + pY - pIM + omegastar*pO) + varphistar;



%13 TotalConsDomImp
c            =   nuCbar^(1/muC)*(hCbar/qCbar)^(1-1/muC)*(c - muC*pH) + (1-nuCbar)^(1/muC)*(imCbar/qCbar)^(1-1/muC)*imC;
 

%14 ConsPriceIndex
0        =   nuCbar*(pHbar/1)^(1-muC)*pH + (1-nuCbar)*(pIMbar/1)^(1-muC)*(  pIM - 
                          (- gammaIMC*(  imC - c - (  imC(-1) - c(-1)) ) - epsilonIM));

%15 TotalInvest
i            =   nuIbar^(1/muI)*(hIbar/qIbar)^(1-1/muI)*(i - muI*( pH - pI)) + (1-nuIbar)^(1/muI)*(imIbar/qIbar)^(1-1/muI)*imI;

%16 InvestPriceIndex
pI            =   nuIbar*(pHbar/pIbar)^(1-muI)*pH
                          + (1-nuIbar)*(pIMbar/pIbar)^(1-muI)*(  pIM - (- gammaIMI*(  imI  - i - (  imI(-1) - i(-1)) ) - epsilonIM));
                          
%17 TotalImports
im            =   imCbar/imbar*imC + imIbar/imbar*imI;

%18 TotalExports
x             = - mustar*(  pX - pY - s - pCX  )
                          + (- gammastar*(  x - ystar - (  x(-1) - ystar(-1) ) ) ) + ystar + nustar; 

%19 TaylorRule
r             =   (1-MPswitch)*(phiR*r(-1)+ (1-phiR)*( phiPi*piC(-1) + phiY*y)
                          + phiDPi*(piC - piC(-1))+ phiDY*(y - y(-1)) + sigmaR*etaR)
                  +MPswitch*0;

%20 ResourceConstraintReal
y             =   hbar/ybar*(hCbar/hbar*(c - muC*pH) + hIbar/hbar*(i - muI*( pH - pI)) + hGbar/hbar*g+ hIGbar/hbar*iG) + xbar/ybar*x;

%21 ResourceConstraintNominal
pY + y        =   cbar/(pYbar*ybar)*( c ) + pIbar*ibar/(pYbar*ybar)*(  pI + i)
                          + pGbar*gbar/(pYbar*ybar)*(  pH + g) + pIGbar*iGbar/(pYbar*ybar)*(  pH + iG) + pXbar*xbar/(pYbar*ybar)*(  pX + x)
                          - pIMbar*imCbar/(pYbar*ybar)*(  pIM + imC  - (- gammaIMC*(  imC - c - (  imC(-1) - c(-1)) ) - epsilonIM) )
                          - pIMbar*imIbar/(pYbar*ybar)*(  pIM + imI - (- gammaIMI*(  imI  - i - (  imI(-1) - i(-1)) ) - epsilonIM));

%22 NetForAssetTradeBalance
1/Rstarbar*bstar = bstar(-1)/gzbar/PiYstarbar
                          + pXbar*xbar/(sbar*pYbar)*(  pX(-1) + x(-1) - s(-1) - pY(-1) )
                          - pIMbar*imbar/(sbar*pYbar)*(  pIM(-1) + im(-1) - s(-1) - pY(-1) );

%23 RelativePriceCons
pH            =   pH(-1) + piH - piC;

%24 RelativePriceExport
pX            =   pX(-1)+ piX - piC;

%25 RelativePriceHomog
pY            =   pY(-1) + piY  - piC;

%26 RelativePriceInvest
pI            =   pI(-1) + piI - piC;

%27 RelativePriceImport
pIM           =   pIM(-1) + piIM - piC;

%28 GovBudget
-pYbar*ybar*lump+pGbar*gbar*(pH+g)+pIGbar*iGbar*(pH+iG)+ bbar/Pibar/gzbar*(b(-1)-piC-gz)+trbar*tr=cbar*(tauC+tauCbar*c)
          +wbar*Nbar*(tauN+tauWf+tauWh)+wbar*Nbar*(tauNbar+tauWfbar+tauWhbar)*(w+N)+kbar/gzbar*(rKbar-delta*pIbar)*(tauKhat+tauKbar*(k(-1)-gz))
          +tauKbar*kbar/gzbar*(rKbar*rK-delta*pIbar*pI)+bbar/Rgovbar*( b  - r);
 
%29 ValuedCons
cItilde        =   alphaG^(1/nuG)*(cIbar/cItildebar)^((nuG-1)/nuG)*cI
                          + (1-alphaG)^(1/nuG)*(gbar/cItildebar)^((nuG-1)/nuG)*g;

%30 CompositeCapital
ktilde        =   alphaK^(1/nuK)*(kbar/ktildebar)^((nuK-1)/nuK)*k(-1)
                          + (1-alphaK)^(1/nuK)*(kGbar/ktildebar)^((nuK-1)/nuK)*kG(-1);

%31 PubCapAccum
kG            =   (1-deltaG)/gzbar*kG(-1) - (1-deltaG)/gzbar*gz + (1-(1-deltaG)/gzbar)*(aiG(-1) - gz);

%32 GovInvestOutlays
iG            =   1/(b0+b1/gzbar)*(  b0*aiG + b1/gzbar*aiG(-1) - b1/gzbar*gz);

%33 TotalConsRicNonRic
c            =   (1-omega)*cIbar/cbar*cI+omega*cJbar/cbar*cJ;

%34 Totaltransfers
tr           =  (1-omega)/trbar*trI+omega/trbar*trJ;  

%35 TransferDistribRule
tr2rot*trI   = (1-tr2rot)*trJ;

%36 NonRicCons
0        =(1+tauCbar)*cJbar*(1/(1+tauCbar)*tauC+cJ)
                         -(1-tauNbar-tauWhbar)*wbar*Nbar*(w+N-(1/(1-tauNbar-tauWhbar))*(tauN+tauWh))-trJ;

 
//Exogenous variables
%38 GovRiskShock
epsilonRPG    =   rhoRPG*epsilonRPG(-1) + sigmaRPG*etaRPG;

%40 ForRiskShock
epsilonRPstar =   rhoRPstar*epsilonRPstar(-1) + sigmaRPstar*etaRPstar;

%41 PermTechnology
gz            =   rhogz*gz(-1) + sigmagz*etagz;

%42 TransTechnology
epsilon       =   rhoepsilon*epsilon(-1) + sigmaepsilon*etaepsilon;

%43 InvestEfficiencyShock
epsilonI      =   rhoI*epsilonI(-1) + sigmaI*etaI;

%44 MarkupWageShock
varphiW       =   rhovarphiW*varphiW(-1) + sigmavarphiW*etavarphiW - rhoMAvarphiW*sigmavarphiW*etavarphiW(-1);

%45 MarkupDomestShock
varphiH       =   rhovarphiH*varphiH(-1) + sigmavarphiH*etavarphiH - rhoMAvarphiH*sigmavarphiH*etavarphiH(-1);

%46 MarkupExportShock
varphiX       =   rhovarphiX*varphiX(-1) + sigmavarphiX*etavarphiX - rhoMAvarphiX*sigmavarphiX*etavarphiX(-1);

%47 MarkupImportShock
varphistar    =   rhovarphistar*varphistar(-1) + sigmavarphistar*etavarphistar - rhoMAvarphistar*sigmavarphistar*etavarphistar(-1);

%48 ImportAdjustCostShock
epsilonIM     =   rhoIM*epsilonIM(-1) + sigmaIM*etaIM;

%49 ExportPreferenceShock
nustar        =   rhonustar*nustar(-1) + sigmanustar*etanustar;

%50 GovConsShock
g             =   (1-FPswitch)*(rhog*g(-1)   + thetaGB*b(-1)+thetaGY*y)+ (1-preag)*sigmag*etag + preag*sigmag*etag(-1);
 
%51 GovInvestBudgetShock
aiG          =   (1-FPswitch)*(rhoaiG*aiG(-1)  + thetaaiGB*b(-1)+thetaaiGY*y) + (1-preaaiG)*sigmaaiG*etaaiG+ preaaiG*sigmaaiG*etaaiG(-1);

%52 GovTransferShock
tr            =   (1-FPswitch)*(rhotr*tr(-1)   + thetatrB*b(-1)+thetatrY*y)+ (1-preatr)*sigmatr*etatr  + preatr*sigmatr*etatr(-1);

%53 ConsTaxShock
tauC          =   (1-FPswitch)*(rhotauC*tauC(-1) + thetatauCB*b(-1)+thetatauCY*y) + (1-preatauC)*sigmatauC*etatauC  + preatauC*sigmatauC*etatauC(-1) ;

%54 SSCfirmsShock
tauWf          =   (1-FPswitch)*(rhotauWf*tauWf(-1)   + thetatauWfB*b(-1)+thetatauWfY*y)+ (1-preatauWf)*sigmatauWf*etatauWf + preatauWf*sigmatauWf*etatauWf(-1);

%55 LabTaxShock
tauN           =   (1-FPswitch)*(rhotauN*tauN(-1)  + thetatauNB*b(-1)+thetatauNY*y)+ (1-preatauN)*sigmatauN*etatauN + preatauN*sigmatauN*etatauN(-1);

%56 SSCemployeeShock
tauWh          =   (1-FPswitch)*(rhotauWh*tauWh(-1)  + (1-preatauWh)*sigmatauWh*etatauWh  + preatauWh*sigmatauWh*etatauWh(-1) + thetatauWhB*b(-1)+thetatauWhY*y);

%57 LumpTaxes
lump           =   (1-FPswitch)*(rhoL*lump(-1)  +  (1-preaL)*sigmaL*etaL  +  preaL*sigmaL*etaL(-1)+ thetaLB*b(-1)+thetaLY*y  );


%59 ForPrices
piYstar        =          B1piYstarpiYstar * piYstar(-1) + sigmaPiYstar*etaPiYstar;

%60 ForOutput
ystar         =           B1ystarystar   * ystar(-1) + B2ystarystar   * ystar(-2) + sigmaYstar*etaYstar;
 
%61 ForInterest 
rstar         =           B1rstarrstar   * rstar(-1) + sigmaRstar*etaRstar;

%62 OilPrices
pO            =           B1pOpO  * pO(-1) + sigmapO*etapO;

%63 CompExportPrices 
pCX           =           B1pCXpCX     * pCX(-1) + sigmapCX*etapCX;


//Measurement equations
%73 Observed real GDP growth  
Dy_obs            =  y - y(-1) + gz + (gEbar-1+gzbar-1)*100 + sigMEDy_eps*MEDy_eps;
 
%74 Observed real consumption growth
Dc_obs            =   c - c(-1) + gz + (gEbar-1+gzbar-1)*100;

%75 Observed real investment growth
Di_obs            =  i - i(-1) + gz + (gEbar-1+gzbar-1)*100;

%76 Observed real export growth
Dx_obs            =  x - x(-1) + gz + (gEbar-1+gzbar-1)*100 + sigMEDx_eps*MEDx_eps;

%77 Observed real import growth
Dim_obs           = im - im(-1) + gz + (gEbar-1+gzbar-1)*100 + sigMEDim_eps*MEDim_eps;

%78 Observed employment 
E                =   betta*gzbar^(1-varsigma)/(1+betta*gzbar^(1-varsigma))*E(+1) + 1/(1+betta*gzbar^(1-varsigma))*E(-1)
                          + (1-betta*gzbar^(1-varsigma)*xiE)*(1-xiE)/((1+betta*gzbar^(1-varsigma))*xiE)*(  N - E);
%79 Observed real wage growth
Dwn_obs           =   1/(1+tauWfbar)*( tauWf - tauWf(-1) ) + w - w(-1) + piC + gz  + ((gzbar-1)+(Pibar-1))*100;

%80 Observed real foreign output growth
Dystar_obs        =  ystar - ystar(-1) + gz + (gEbar-1+gzbar-1)*100;

%83 Observed real direct tax revenues
dtxwin_obs=tauN+alfa/(1-alfa)*(1+tauWfbar)/aabar*(1-delta*pIbar/rKbar)*tauKhat
                 +alfa/(1-alfa)/aabar*tauKbar*(1-delta*pIbar/rKbar)*tauWf
                 -delta*alfa/(1-alfa)/aabar*tauKbar*pIbar/rKbar*(1+tauWfbar)*(pI-rK)
                 -alfa/(1-alfa)*(1+tauWfbar)/aabar*tauKbar*(1-delta*pIbar/rKbar)*xi2*(kG(-1)-k(-1));

%69 Observed import inflation 
piIM_obs=piIM +  (Pibar-1)*100+ sigMEpiIM_eps*MEpiIM_eps; 

%70 Observed GDP deflator inflation 
piY_obs=piY +(Pibar-1)*100 + sigMEpiY_eps*MEpiY_eps; 


%67 Observed CPI inflation 
piC_obs=piC+(Pibar-1)*100 + sigMEpiC_eps*MEpiC_eps; 

%68 Observed nom. interest rate (note that interest rates and inflation 
%are in absolute deviations from steady state)
r_obs=4*r+(Rbar-1)*400;   


%71 Observed foreign inflation 
piYstar_obs=piYstar+(PiYstarbar-1)*100; 

%72 Observed foreign nom. interest rate 
rstar_obs=4*rstar+(Rstarbar-1)*400;

%73 Observed gov. debt
b_obs=b+ sigMEb_eps*MEb_eps;

end; 


 

%set parameters to estimated posterior values
root1ystar=0.91944;
root2ystar=0.58352;
nuG=0.29373;
nuK=0.84277;
gammaI=6.1001;
gammaIMC=4.1623;
gammaIMI=0.80401;
gammastar=2.6934;
muC=1.9845;
muI=1.7503;
xiW=0.84747;
chiW=0.52613;
xiH=0.92197;
chiH=0.81703;
xiX=0.55272;
chiX=0.81097;
xistar=0.072364;
chistar=0.4448;
omegastar=0.13702;
kappa=0.5724;
xiE=0.77105;
phiR=0.85776;
phiPi=1.7323;
phiDPi=0.20062;
phiDY=0.11237;
phiY=0.18953;
omega=0.18308;
tr2rot=0.29795;
cJcISSratio=0.8296;
sigmagz=0.38001;
rhoepsilon=0.93955;
rhogz=0.24142;
sigmaepsilon=0.51552;
rhoI=0.27326;
sigmaI=0.57455;
rhoRPG=0.83856;
sigmaRPG=0.39087;
sigmaIM=3.9796;
sigmanustar=7.2265;
rhoIM=0.93236;
rhonustar=0.86496;
sigmaYstar=1.4274;
rhoRPstar=0.85265;
sigmaRPstar=0.52362;
sigmaR=0.13329;
sigmavarphiW=0.23;
sigmavarphiH=0.19214;
sigmavarphiX=1.1102;
sigmavarphistar=1.1629;
rhovarphiH=0.56866;
rhovarphiX=0.48864;
rhovarphistar=0.99173;
rhovarphiW=0.9176;
rhoMAvarphiH=0.72024;
rhoMAvarphiX=0.81171;
rhoMAvarphistar=0.20774;
rhoMAvarphiW=0.96193;
sigmaPiYstar=0.31121;
sigmaRstar=0.16164;
sigmapO=15.0528;
sigmapCX=1.1803;
B1piYstarpiYstar=0.54144;
B1rstarrstar=0.90852;
B1pOpO=0.95263;
B1pCXpCX=0.96975;
rhoL=0.6838;
sigmaL=0.79791;
rhoaiG=0.69698;
rhotr=0.71939;
rhotauC=0.91208;
rhotauWf=0.6911;
rhotauWh=0.73535;
rhotauN=0.80869;
sigmatr=2.3684;
sigmaaiG=3.2765;
sigmatauC=0.22051;
sigmatauWf=0.19241;
sigmatauWh=0.23025;
sigmatauN=0.59069;
sigmag=0.50835;
rhog=0.77065;
preaaiG=0.93389;
preatauC=0.30574;
preatauWf=0.7661;
preatauWh=0.25936;
preatauN=0.11073;
preatr=0.81338;
preag=0.056318;
preaL=0.90276;
thetaGB=-0.021307;
thetatrB=-0.13518;
thetaaiGB=-0.17776;
thetatauWfB=0.0078988;
thetatauWhB=-0.012987;
thetatauNB=0.047942;
thetaGY=0.063841;
thetatrY=0.097171;
thetaaiGY=0.55172;
thetatauWfY=-0.02921;
thetatauWhY=-0.051386;
thetatauNY=0.04088;
thetaLY=0.20729;
thetaLB=0.077284;


%Set variances to 1
sigmag=1;
sigmatr=1;
sigmaaiG=1;
sigmatauC=1;
sigmatauN=1;
sigmatauWh=1;
sigmatauWf=1;
sigmatauK=1;

%switch off prea and AR(1), feedbacks
preaaiG         =	0;
preatauC        =	0;
preatauWf       =	0;
preatauWh       =	0;
preatauN        =	0;
preatauK        =	0;
preaL           =	0;
preatr          =	0;
preag           =	0;
rhog            =	0.0;
rhotr           =	0.0;
rhoaiG      	=	0.0;
rhotauC         =	0.0;
rhotauWf        =	0.0;
rhotauWh       	=	0.0;
rhotauN       	=	0.0;
rhotauK     	=	0;
rhoL            =	0; 
thetaLY         =	0;
thetaGB         =	0;
thetaGY         =	0;
thetatrB        =	0;
thetatrY        =	0;
thetaaiGB       =	0;
thetaaiGY       =	0;
thetatauCB      =	0;
thetatauCY      =	0;
thetatauWfB     =	0;
thetatauWfY  	=	0;
thetatauWhB     =	0;
thetatauWhY 	=	0;
thetatauNB      =	0;
thetatauNY      =	0;
thetatauKB      =	0;
thetatauKY      =	0; 
%use Standard Taylor rule
phiR            =   0;
phiPi           =   1.5;
phiDPi          =   0;
phiY            =   0.5/4;
phiDY           =   0;
  

steady;


%get steady state
NAWMDynare_steadystate([],[],1); %print steady state and parameters

%tax bases etc
ybarbase=M_.params(loc(M_.param_names(:,:),'ybar'));
gbarbase=M_.params(loc(M_.param_names(:,:),'gbar'));
sCbase  =M_.params(loc(M_.param_names(:,:),'sC'));
sWNbase =M_.params(loc(M_.param_names(:,:),'wbar'))*M_.params(loc(M_.param_names(:,:),'Nbar'))/ybarbase;
scapbase=M_.params(loc(M_.param_names(:,:),'kbar'))/M_.params(loc(M_.param_names(:,:),'gzbar'))*(M_.params(loc(M_.param_names(:,:),'rKbar'))-M_.params(loc(M_.param_names(:,:),'delta'))*M_.params(loc(M_.param_names(:,:),'pIbar')))/ybarbase;


varnamez={'y';'c';'i';'x';'im';'N';'w';'r';'piC';
    'lump';'b'; 'cJ'; 'cI'; 'trI'; 'trJ';'g';'aiG'; 'iG';'tr';'tauC';
    'tauWf'; 'tauWh';'tauN';};


%%%%%%%%%%%%%%%%%%%%%
%EERP Simulation %%%%
%%%%%%%%%%%%%%%%%%%%%
shocks;

var etatauWf;
periods 1:4, 5:8;
values -0.3346 -0.2545; %baseline

var etatauN;
periods 1:4, 5:8;
values -0.2160,-0.1647;%baseline 

var etatauC;
periods 1:4, 5:8;
values -0.2396,-0.1826;

var etag;
periods 1:4, 5:8;
values 0.5233,0.3986;

var etatr;
periods 1:4, 5:8;
values 0.8136,0.6201;

var etaaiG;
periods 1:4, 5:8;
values 11.1607,8.5036;

var MPswitch;
periods 1:8;
values 1 ;
 
var FPswitch;
periods 1:8;
values 1 ;
end;

simul(periods=1000,stack_solve_algo=0);

show_horz=100;
for hh=1:1:size(varnamez,1),
    if strmatch(varnamez(hh,:),'tauK')==1,
        resp_mat(hh,1:show_horz)=oo_.endo_simul(loc(M_.endo_names(:,:),char(varnamez(hh,:))),2:show_horz+1)*scapbase;
    elseif strmatch(varnamez(hh,:),'tauWf')==1,
        resp_mat(hh,1:show_horz)=oo_.endo_simul(loc(M_.endo_names(:,:),char(varnamez(hh,:))),2:show_horz+1)*sWNbase;
    elseif strmatch(varnamez(hh,:),'tauN')==1,
        resp_mat(hh,1:show_horz)=oo_.endo_simul(loc(M_.endo_names(:,:),char(varnamez(hh,:))),2:show_horz+1)*sWNbase;
    elseif strmatch(varnamez(hh,:),'tauC')==1,
        resp_mat(hh,1:show_horz)=oo_.endo_simul(loc(M_.endo_names(:,:),char(varnamez(hh,:))),2:show_horz+1)*sCbase;
    elseif strmatch(varnamez(hh,:),'g')==1,
        resp_mat(hh,1:show_horz)=oo_.endo_simul(loc(M_.endo_names(:,:),char(varnamez(hh,:))),2:show_horz+1)*sG;
    elseif strmatch(varnamez(hh,:),'tr')==1,
        resp_mat(hh,1:show_horz)=oo_.endo_simul(loc(M_.endo_names(:,:),char(varnamez(hh,:))),2:show_horz+1)*sTR;
    elseif strmatch(varnamez(hh,:),'trJ')==1,
        resp_mat(hh,1:show_horz)=oo_.endo_simul(loc(M_.endo_names(:,:),char(varnamez(hh,:))),2:show_horz+1)*sTR;
    elseif strmatch(varnamez(hh,:),'trI')==1,
        resp_mat(hh,1:show_horz)=oo_.endo_simul(loc(M_.endo_names(:,:),char(varnamez(hh,:))),2:show_horz+1)*sTR;
    elseif strmatch(varnamez(hh,:),'aiG')==1
        resp_mat(hh,1:show_horz)=oo_.endo_simul(loc(M_.endo_names(:,:),char(varnamez(hh,:))),2:show_horz+1)*sIG;
    elseif  strmatch(varnamez(hh,:),'iG')==1
        resp_mat(hh,1:show_horz)=oo_.endo_simul(loc(M_.endo_names(:,:),char(varnamez(hh,:))),2:show_horz+1)*sIG;
    else
        resp_mat(hh,1:show_horz)=oo_.endo_simul(loc(M_.endo_names(:,:),char(varnamez(hh,:))),2:show_horz+1);
    end
end


resp_mat_fis(1,:)=-oo_.endo_simul(loc(M_.endo_names(:,:),'tauWf'),2:end)*sWNbase-oo_.endo_simul(loc(M_.endo_names(:,:),'tauN'),2:end)*sWNbase-oo_.endo_simul(loc(M_.endo_names(:,:),'tauC'),2:end)*sCbase+oo_.endo_simul(loc(M_.endo_names(:,:),'g'),2:end)*sG+oo_.endo_simul(loc(M_.endo_names(:,:),'tr'),2:end)*sTR+oo_.endo_simul(loc(M_.endo_names(:,:),'aiG'),2:end)*sIG;
resp_mat_y(1,:)=oo_.endo_simul(loc(M_.endo_names(:,:),'y'),2:end);
resp_mat_Dy(1,:)=oo_.endo_simul(loc(M_.endo_names(:,:),'Dy_obs'),2:end);
fis_string='EERP';



print_plot_stand_multipliers;

        



