%calculate and print fiscal multipliers


%discounting with real ex post interest rate on gov. paper.
Rgov_real=1+M_.params(loc(M_.param_names(:,:),'RgovRealAnnual'))/400;
disc=1/Rgov_real;
disc_vec=disc.^[0:1:length(resp_mat_fis)-1];
disc_mat=repmat(disc_vec,size(resp_mat_y,1),1);

mult_cum=cumsum(ybarbase.*resp_mat_y,2)./cumsum(ybarbase.*resp_mat_fis,2);
mult_pv=cumsum(disc_mat.*ybarbase.*resp_mat_y,2)./cumsum(disc_mat.*ybarbase.*resp_mat_fis,2);

disp(' ');
disp('Standardized Fiscal Multipliers (present value, 2 yrs stimulus, 2 yrs accommodation):');
disp('-------------------------------------------------------------------------------------');
fprintf('                   1Q     4Q     8Q     16Q     64Q     Inf     Max     Min\n' );
fprintf('EERP            : %3.2f\t %3.2f\t%3.2f\t%3.2f\t%3.2f\t%3.2f\t%3.2f\t%3.2f\n',mult_pv(1,1),mult_pv(1,4),mult_pv(1,8),mult_pv(1,16),mult_pv(1,64),mult_pv(1,end),max(mult_pv(1,:)),min(mult_pv(1,:)));
disp(' ');


disp(' ');
disp('Output (avg. percent dev. from ss) after standardized fiscal stimulus (2 yrs stimulus, 2 yrs accommodation):');
disp('------------------------------------------------------------------------------------------------------------');
fprintf('                   1Q     1Y      2Y     3Y     4Y     5Y     \n' );
fprintf('EERP            : %3.2f\t %3.2f\t %3.2f\t%3.2f\t%3.2f\t%3.2f\n',resp_mat_y(1,1),mean(resp_mat_y(1,1:4)),mean(resp_mat_y(1,5:8)),mean(resp_mat_y(1,9:12)),mean(resp_mat_y(1,13:16)),mean(resp_mat_y(1,17:20)));
disp(' ');


disp(' ');
disp('Size of EERP in 2009 and 2010 (in percent of baseline GDP):');
disp('-----------------------------------------------------------');
disp([num2str(mean(resp_mat_fis(1,1:4)),2),' and ',num2str(mean(resp_mat_fis(1,5:8)),3)]);
disp(' ');
